//+------------------------------------------------------------------+
//|                                                        Kloss.mq5 |
//|                                          Copyright 2012, Integer |
//|                          https://login.mql5.com/ru/users/Integer |
//+------------------------------------------------------------------+

#property copyright "Integer"
#property link "https://login.mql5.com/ru/users/Integer"
#property description "   MQL4,  - http://www.mql4.com/ru/users/klopka,    - http://codebase.mql4.com/ru/3692"
#property version   "1.00"

#include <Trade/Trade.mqh>
#include <Trade/SymbolInfo.mqh>
#include <Trade/DealInfo.mqh>
#include <Trade/PositionInfo.mqh>

CTrade Trade;
CDealInfo Deal;
CSymbolInfo Sym;
CPositionInfo Pos;

input double                           Lots              =  0.1;           /*Lots*/          // ,   0  MaximumRisk.
input double                           MaximumRisk       =  0.05;          /*MaximumRisk*/   //  (  Lots=0).
input int                              StopLoss          =  550;           /*StopLoss*/      //   , 0 -  .
input int                              TakeProfit        =  550;           /*TakeProfit*/    //   , 0 -  .
input bool                             RevClose          =  true;          /*RevClose*/      //      

input int                              MAPeriod          =  1;	            /*MAPeriod*/      //  MA
input ENUM_MA_METHOD                   MAMethod          =  MODE_LWMA;	   /*MAMethod*/      //  MA
input ENUM_APPLIED_PRICE               MAPrice           =  PRICE_TYPICAL;	/*MAPrice*/       //  MA
input int                              MAShift           =  5;	            /*MAShift*/       //           
input int                              PShift            =  1;	            /*PShift*/        //           MA

input int                              CCIPeriod         =  10;	         /*CCIPeriod*/     //  CCI
input ENUM_APPLIED_PRICE               CCIPrice          =  PRICE_WEIGHTED;/*CCIPrice*/      //  CCI
input int                              CCIDiffer         =  120;           /*CCIDiffer*/     //  CCI (    0    )
input int                              CCIShift          =  0;	            /*CCIShift*/      //     CCI

input int                              StKPeriod         =  5;	            /*StKPeriod*/     //   
input int                              StDPeriod         =  3;	            /*StDPeriod*/     //  D 
input int                              StSPeriod         =  3;	            /*StSPeriod*/     //  S 
input ENUM_MA_METHOD                   StMethod          =  MODE_SMA;	   /*StMethod*/      //  
input ENUM_STO_PRICE                   StPrice           =  STO_LOWHIGH;	/*StPrice*/       //  
input int                              StShift           =  0;	            /*StShift*/       //     
input int                              StDiffer          =  20;            /*StDiffer*/      //   (    50    )
input int                              CommonShift       =  1;             /*CommonShift*/   //   (   Shift  )

input bool                             MWMode            =  true;          /*MWMode*/        //       



int ma_shift,p_shift,cci_shif,st_shift;
bool ZeroBar;

int MAHand=INVALID_HANDLE;
int CCIHand=INVALID_HANDLE;
int StHand=INVALID_HANDLE;

double MABuf[1];
double CCIBuf[1];
double StMBuf[1];
double StSBuf[1];
double cl[1];
   
//--- input parameters


int Handle=INVALID_HANDLE;

datetime ctm[1];
datetime LastTime;
double lot,slv,msl,tpv,mtp;
string gvp;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit(){
   
   ma_shift=MAShift+CommonShift;
   p_shift=PShift+CommonShift;
   cci_shif=CCIShift+CommonShift;
   st_shift=StShift+CommonShift;
   ZeroBar=(ma_shift==0 || p_shift==0 || cci_shif==0 || st_shift==0);

   //    
   gvp=MQL5InfoString(MQL5_PROGRAM_NAME)+"_"+_Symbol+"_"+IntegerToString(PeriodSeconds()/60)+"_"+IntegerToString(AccountInfoInteger(ACCOUNT_LOGIN));
   if(AccountInfoInteger(ACCOUNT_TRADE_MODE)==ACCOUNT_TRADE_MODE_DEMO)gvp=gvp+"_d";
   if(AccountInfoInteger(ACCOUNT_TRADE_MODE)==ACCOUNT_TRADE_MODE_REAL)gvp=gvp+"_r";
   if(MQL5InfoInteger(MQL5_TESTING))gvp=gvp+"_t";
   DeleteGV();

   //  ...
   
   MAHand=iMA(NULL,PERIOD_CURRENT,MAPeriod,0,MAMethod,MAPrice);
   CCIHand=iCCI(NULL,PERIOD_CURRENT,CCIPeriod,CCIPrice);
   StHand=iStochastic(NULL,PERIOD_CURRENT,StKPeriod,StDPeriod,StSPeriod,StMethod,StPrice);

   if(MAHand==INVALID_HANDLE || CCIHand==INVALID_HANDLE || StHand==INVALID_HANDLE){
      Alert("  ,  ");
      return(-1);
   }   
   
   if(!Sym.Name(_Symbol)){
      Alert("  CSymbolInfo,  ");    
      return(-1);
   }

   Print("  ");
   
   return(0);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason){
   if(MAHand!=INVALID_HANDLE)IndicatorRelease(MAHand);
   if(CCIHand!=INVALID_HANDLE)IndicatorRelease(CCIHand);
   if(StHand!=INVALID_HANDLE)IndicatorRelease(StHand);
   DeleteGV();   
}

//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick(){

   if(!MWMode_F2())return;

   if(CopyTime(_Symbol,PERIOD_CURRENT,0,1,ctm)==-1){
      return;
   }
   if(ZeroBar || ctm[0]!=LastTime){
      
      // 
      if(!Indicators()){
         return;
      }   
      
      // 
      bool CloseBuy=false;
      bool CloseSell=false;
      bool OpenBuy=SignalOpenBuy();
      bool OpenSell=SignalOpenSell();
      
      if(RevClose){
         CloseBuy=OpenSell;
         CloseSell=OpenBuy;
      }
      

      // 
      if(Pos.Select(_Symbol)){
         if(CloseBuy && Pos.PositionType()==POSITION_TYPE_BUY){
            if(!Sym.RefreshRates()){
               return;  
            }
            if(!Trade.PositionClose(_Symbol,Sym.Spread()*3)){
               return;
            }
         }
         if(CloseSell && Pos.PositionType()==POSITION_TYPE_SELL){
            if(!Sym.RefreshRates()){
               return;  
            }         
            if(!Trade.PositionClose(_Symbol,Sym.Spread()*3)){
               return;
            }
         }         
      }
      
      // 
      if(!Pos.Select(_Symbol)){
            if(OpenBuy && !OpenSell && !CloseBuy){ 
               if(!Sym.RefreshRates())return;         
               if(!SolveLots(lot))return;
               slv=SolveBuySL(StopLoss);
               tpv=SolveBuyTP(TakeProfit);
                  if(CheckBuySL(slv) && CheckBuyTP(tpv)){
                     Trade.SetDeviationInPoints(Sym.Spread()*3);
                     MWMode_F1(slv,tpv);
                        if(Trade.Buy(lot,_Symbol,0,slv,tpv,"")){
                           MWMode_F2();
                        }
                        else{
                           return;
                        }
                  }
                  else{
                     Print(" Buy  ,    ");
                  }         
            }
            // 
            if(OpenSell && !OpenBuy && !CloseSell){
               if(!Sym.RefreshRates())return;         
               if(!SolveLots(lot))return;
               slv=SolveSellSL(StopLoss);
               tpv=SolveSellTP(TakeProfit);
                  if(CheckSellSL(slv) && CheckSellTP(tpv)){
                     Trade.SetDeviationInPoints(Sym.Spread()*3);
                     MWMode_F1(slv,tpv);
                        if(Trade.Sell(lot,_Symbol,0,slv,tpv,"")){
                           MWMode_F2();
                        }
                        else{
                           return;
                        }
                  }
                  else{
                     Print(" Sell  ,    ");
                  }          
            }
      }            
      LastTime=ctm[0];
   }
}

//+------------------------------------------------------------------+
//|      ,                    |
//+------------------------------------------------------------------+
bool Indicators(){
   if(
      CopyBuffer(MAHand,0,ma_shift,1,MABuf)==-1 ||
      CopyBuffer(CCIHand,0,cci_shif,1,CCIBuf)==-1 ||
      CopyBuffer(StHand,0,st_shift,1,StMBuf)==-1 ||
      CopyBuffer(StHand,1,st_shift,1,StSBuf)==-1 ||
      CopyClose(_Symbol,PERIOD_CURRENT,p_shift,1,cl)==-1
   )return(false);      

   return(true);
}
 
//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
bool SignalOpenBuy(){
   return(CCIBuf[0]<-CCIDiffer && StMBuf[0]<50-StDiffer && cl[0]>MABuf[0]);
}

//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
bool SignalOpenSell(){
   return(CCIBuf[0]>CCIDiffer && StMBuf[0]>50+StDiffer && cl[0]<MABuf[0]);
}

//+------------------------------------------------------------------+
//|      buy                               |
//+------------------------------------------------------------------+
double SolveBuySL(int StopLossPoints){
   if(StopLossPoints==0)return(0);
   return(Sym.NormalizePrice(Sym.Ask()-Sym.Point()*StopLossPoints));
}

//+------------------------------------------------------------------+
//|      buy                             |
//+------------------------------------------------------------------+
double SolveBuyTP(int TakeProfitPoints){
   if(TakeProfitPoints==0)return(0);
   return(Sym.NormalizePrice(Sym.Ask()+Sym.Point()*TakeProfitPoints));   
}

//+------------------------------------------------------------------+
//|      sell                               |
//+------------------------------------------------------------------+
double SolveSellSL(int StopLossPoints){
   if(StopLossPoints==0)return(0);
   return(Sym.NormalizePrice(Sym.Bid()+Sym.Point()*StopLossPoints));
}

//+------------------------------------------------------------------+
//|      sell                             |
//+------------------------------------------------------------------+
double SolveSellTP(int TakeProfitPoints){
   if(TakeProfitPoints==0)return(0);
   return(Sym.NormalizePrice(Sym.Bid()-Sym.Point()*TakeProfitPoints));   
}

//+------------------------------------------------------------------+
//|       buy                  |
//+------------------------------------------------------------------+
double BuyMSL(){
   return(Sym.NormalizePrice(Sym.Bid()-Sym.Point()*Sym.StopsLevel()));
}

//+------------------------------------------------------------------+
//|       buy                |
//+------------------------------------------------------------------+
double BuyMTP(){
   return(Sym.NormalizePrice(Sym.Ask()+Sym.Point()*Sym.StopsLevel()));
}

//+------------------------------------------------------------------+
//|       sell                 |
//+------------------------------------------------------------------+
double SellMSL(){
   return(Sym.NormalizePrice(Sym.Ask()+Sym.Point()*Sym.StopsLevel()));
}

//+------------------------------------------------------------------+
//|       sell               |
//+------------------------------------------------------------------+
double SellMTP(){
   return(Sym.NormalizePrice(Sym.Bid()-Sym.Point()*Sym.StopsLevel()));
}

//+------------------------------------------------------------------+
//|      buy                                 |
//+------------------------------------------------------------------+
bool CheckBuySL(double StopLossPrice){
   if(StopLossPrice==0)return(true);
   return(StopLossPrice<BuyMSL());
}

//+------------------------------------------------------------------+
//|      buy                               |
//+------------------------------------------------------------------+
bool CheckBuyTP(double TakeProfitPrice){
   if(TakeProfitPrice==0)return(true);
   return(TakeProfitPrice>BuyMTP());
}

//+------------------------------------------------------------------+
//|      sell                                 |
//+------------------------------------------------------------------+
bool CheckSellSL(double StopLossPrice){
   if(StopLossPrice==0)return(true);
   return(StopLossPrice>SellMSL());
}

//+------------------------------------------------------------------+
//|      sell                              |
//+------------------------------------------------------------------+
bool CheckSellTP(double TakeProfitPrice){
   if(TakeProfitPrice==0)return(true);
   return(TakeProfitPrice<SellMTP());
}

//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+
bool SolveLots(double & aLots){
      if(Lots==0){
         aLots=fLotsNormalize(AccountInfoDouble(ACCOUNT_FREEMARGIN)*MaximumRisk/1000.0);        
      }
      else{
         aLots=Lots;         
      }
   bool rv=true;   
   return(rv);
}

//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
double fLotsNormalize(double aLots){
   aLots-=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);
   aLots/=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_STEP);
   aLots=MathRound(aLots);
   aLots*=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_STEP);
   aLots+=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);
   aLots=NormalizeDouble(aLots,2);
   aLots=MathMin(aLots,SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX));
   aLots=MathMax(aLots,SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN));   
   return(aLots);
}

//+------------------------------------------------------------------+
//|         gvp         | 
//+------------------------------------------------------------------+
void DeleteGV(){
   if(MQL5InfoInteger(MQL5_TESTING)){
      for(int i=GlobalVariablesTotal()-1;i>=0;i--){
         if(StringFind(GlobalVariableName(i),gvp,0)==0){
            GlobalVariableDel(GlobalVariableName(i));
         }
      }
   }
}   

//+------------------------------------------------------------------+
//|       MWMode                      |
//+------------------------------------------------------------------+
void MWMode_F1(double & aStopLossValue,double & aTakeProfitValue){
   if(!MWMode)return;
   GlobalVariableSet(gvp+"_mwm_sl",aStopLossValue);
   GlobalVariableSet(gvp+"_mwm_tp",aTakeProfitValue);
   aStopLossValue=0;
   aTakeProfitValue=0;
}

//+------------------------------------------------------------------+
//|       MWMode                             |
//+------------------------------------------------------------------+
bool MWMode_F2(){
      if(!MWMode){
         return(true);
      }         
      if(GlobalVariableCheck(gvp+"_mwm_sl") || GlobalVariableCheck(gvp+"_mwm_tp")){
         if(Pos.Select(_Symbol)){
            if(Pos.StopLoss()==0 && Pos.TakeProfit()==0){
               slv=GlobalVariableGet(gvp+"_mwm_sl");
               tpv=GlobalVariableGet(gvp+"_mwm_tp");
               if(slv!=0 || tpv!=0){
                  if(!Sym.RefreshRates()){
                     return(false);
                  }              
                  switch(Pos.PositionType()){
                     case POSITION_TYPE_BUY:
                        if(slv!=0){
                           slv=MathMin(slv,Sym.NormalizePrice(Sym.Bid()-Sym.Point()*(Sym.Spread()+Sym.StopsLevel()+1)));
                        }
                        if(tpv!=0){
                           tpv=MathMax(tpv,Sym.NormalizePrice(Sym.Ask()+Sym.Point()*(Sym.StopsLevel()+1)));
                        }
                        if(Trade.PositionModify(_Symbol,slv,tpv)){
                           GlobalVariableDel(gvp+"_mwm_sl");
                           GlobalVariableDel(gvp+"_mwm_tp");
                        }
                        else{
                           return(false);
                        }
                     break;
                     case POSITION_TYPE_SELL:
                        if(slv!=0){
                           slv=MathMax(slv,Sym.NormalizePrice(Sym.Ask()+Sym.Point()*(Sym.Spread()+Sym.StopsLevel()+1)));
                        }
                        if(tpv!=0){
                           tpv=MathMin(tpv,Sym.NormalizePrice(Sym.Bid()-Sym.Point()*(Sym.StopsLevel()+1)));
                        }
                        if(Trade.PositionModify(_Symbol,slv,tpv)){
                           GlobalVariableDel(gvp+"_mwm_sl");
                           GlobalVariableDel(gvp+"_mwm_tp");
                        }
                        else{
                           return(false);
                        }
                     break;
                  }
               }
            }
         }
      }
   return(true);
}